;;; super-smart-find.el --- an extension of smart-find.el
;;; Copyright (c) 1995 Katsumi Yamaoka <yamaoka@ga.sony.co.jp>
;;; (smart-find.el: Copyright (c) 1990 by Wayne Mesard.)

(provide 'super-smart-find)
(defconst super-smart-find-version "1.2"
  "Version numbers of this version of super-smart-find.el")
(defconst super-smart-find-patch-level "0"
  "Patch level of this version of super-smart-find.el")

;;; This program is free software; you can redistribute it and/or modify
;;; it under the terms of the GNU General Public License as published by
;;; the Free Software Foundation; either version 2 of the License, or
;;; (at your option) any later version.
;;; 
;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;; 
;;; You should have received a copy of the GNU General Public License
;;; along with this program; if not, write to the Free Software
;;; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

;;; HISTORY
;;;
;;; v1.20    95.06.07
;;;     $B!&:45W4V$5$s(B <KHB10110@niftyserve.or.jp> $B$N$4;XE&$K$h$j!"(B
;;;       $BJQ?t(B super-smart-find-self-insert-command-list $B$r?7@_$7!"(B
;;;       nil $B$@$C$?$i(B apropos $B$G(B *-self-insert-command $B$r<+F0Cj=P!"(B
;;;       $B4{CN$N(B *-self-insert-command $B$N%j%9%H$@$C$?>l9g$K$O$=$l$r(B
;;;       $B;2>H$9$k$h$&$KJQ99!#(B
;;;     $B!&85$N(B minibuffer-setup-hook $B$NCM$r2u$5$J$$$h$&$KJQ99!#(B
;;;
;;; v1.10    95.05.12
;;;     $B!&1vLn$5$s(B <jun@p5.nm.fujitsu.co.jp> $B$N$4Ds8@$K$h$j!"(B
;;;       canna-self-insert-command $B$rDI2C!#(B
;;;     $B!&4X?t(B super-smart-find-load-file $B$rDI2C!#(B
;;;     $B!&4X?t(B super-smart-find-mime-insert-file $B$rDI2C!#(B
;;;       (tm-ML $B$NKv@J$r1x$7$F$k<T$H$7$F$O!"$3$l$OF~$l$H$+$M$P(B :-)
;;;
;;; v1.00    95.05.09

;;; DESCRIPTION
;;;
;;;     $B$*$3$,$^$7$/$b(B super- $B$NL>$r4'$9$k$3$N%W%m%0%i%`$O!"(BMule-2.x 
;;;     $B>e$G!"$"$i$i$8$a@_Dj$5$l$?J#?t$N%G%#%l%/%H%j$N2<$KB8:_$9$k%U%!(B
;;;     $B%$%k$r!"%G%#%l%/%H%jL>$N;XDj$rI,MW$H$;$:$K(B completion $B5!G=$rJ;(B
;;;     $BMQ$7$FFI$_9~$`$3$H$,$G$-$k$h$&$K$9$k$?$a$N!"(Bfind-file $B7O$N4X?t(B
;;;     $B$K(B smart-find $B$N5!G=$rIU2C$9$k$?$a$N%W%m%0%i%`$G$9!#(B
;;;     $B$3$l$r;H$&$?$a$K$O(B smart-find.el $B$,I,MW$G$9!#(B
;;;     Emacs ver.18 $B$G$b6J$,$j$J$j$K;H$($^$9$,!"$$$m$$$m$HLdBj$,$"$j(B
;;;     $B$^$9!#(B($B8e=R(B)

;;; HOW TO USE
;;;
;;;     $B$3$N%U%!%$%k$H(B smart-find.el $B$r(B load-path $B$N%G%#%l%/%H%j$N2<$K(B
;;;     $B%3%T!<$7$F(B byte-compile-file $B$7$F2<$5$$!#$=$7$F(B ~/.emacs $B$K(B
;
;(require 'super-smart-find)
;(define-key global-map "\C-x\C-f" 'super-smart-find-file)
;(define-key global-map "\C-x4f"   'super-smart-find-file-other-window)
;(define-key global-map "\C-xi"    'super-smart-find-insert-file)
;(define-key global-map "\C-x\C-w" 'super-smart-find-write-file)
;(define-key global-map "\C-x5f"   'super-smart-find-file-other-frame)
;(define-key global-map "\C-x4l"   'super-smart-find-load-file)
;(add-hook 'mime-mode-hook
;	  '(lambda ()
;	     (define-key (current-local-map)
;	       "\C-c\C-x\C-i" 'super-smart-find-mime-insert-file)
;	     (if (string-match "^19\\." emacs-version)
;		 (define-key (current-local-map) [menu-bar mime file]
;		   '("Insert File" . super-smart-find-mime-insert-file))
;	       )))
;
;;;     $B$H=q$$$F$*$/$3$H$K$h$C$F!"(Bfind-file, file-other-window, $B$*$h$S(B
;;;     find-file-other-frame $B$J$I!"$=$l$>$l$N%3%^%s%I$r=>MhDL$j;H$&$3(B
;;;     $B$H$,$G$-$k$3$H$K2C$($F!":G=i$K(B `=' $B$r%?%$%W$9$k$3$H$K$h$C$F(B 
;;;     smart-find $B$N5!G=$K@Z$j49$o$j$^$9!#(B(Emacs ver.18 $B$G$O(B add-hook
;;;     $B$rDj5A$9$k$+!"JL$NJ}K!$G@_Dj$7$F2<$5$$!#(B)
;;;     smart-find $B$G%U%!%$%k$r%5!<%A$9$k%Q%9$O(B smart-find-file-path 
;;;     $B$H$$$&JQ?t$G@_Dj$G$-$^$9$N$G!"$"$J$?$,IQHK$K%"%/%;%9$9$k%U%!%$(B
;;;     $B%k$rCV$$$F$"$k%G%#%l%/%H%j$r(B ~/.emacs $B$NCf$K(B
;
;(setq smart-find-file-path
;      '(
;	"~"
;	"~/elisp"
;	"/usr/local/mule/site-liep"
;	"/usr/local/mule/lisp"
;	))
;
;;;     $B$J$I$H=q$$$F$*$/$HNI$$$G$7$g$&!#(B
;;;
;;;     $B$3$N%W%m%0%i%`$O:G=i$K2!$5$l$?%-!<$,2?$+$N(B self-insert-command
;;;     $B$+$I$&$+$NH=Dj$r$7$F$$$^$9!#%G%U%)%k%H$G$O(B apropos $B$r;H$C$FB8(B
;;;     $B:_$9$k$9$Y$F$N(B self-insert-command $B$r8!=P$9$k$h$&$K$J$C$F$$$^(B
;;;     $B$9$,!"$"$i$+$8$a$o$+$C$F$$$k>l9g$K$O(B
;
;(setq super-smart-find-self-insert-command-list
;      '(canna-self-insert-command
;	egg-self-insert-command
;	self-insert-command
;	tcode-self-insert-command-maybe))
;
;;;     $B$J$I$H@_Dj$7$F$*$/$3$H$K$h$C$F!"(Bapropos $B$r<B9T$9$k$?$a$NCY$l$r(B
;;;     $B2sHr$9$k$3$H$,$G$-$^$9!#(B
;;;
;;;     $B$=$l$+$i!"(BMule $B$r5/F0$7$?8e$G;O$a$F(B super-smart-find-file $B$J$I(B
;;;     $B$r<B9T$7$?$H$-$K!"%_%K%P%C%U%!$K(B "Loading cl-macs...done" $B$J$I(B
;;;     $B$H$$$&%a%C%;!<%8$,=P$FHQ$$>l9g$K$O!"(B~/.emacs $B$K(B
;
;(require 'cl)
;(load-library "cl-macs")
;
;;;     $B$H=q$$$F$*$/$N$,NI$$$+$b$7$l$^$;$s!#(B

;;; BUGS
;;;
;;;     $B:G=i$K2!$7$?%-!<$,%U%!%$%kL>$r;XDj$9$k$?$a$NJ8;z$G$O$J$/$F%3%^(B
;;;     $B%s%I$@$C$?>l9g$K!"(BMule-2.x $B$G$O0lIt$N%3%^%s%I$,;H$($J$$>l9g$,(B
;;;     $B$"$j$^$9!#$^$?(B Mule-1.x/NEmacs/NEpoch $B$J$I$G$O!"$[$H$s$I$N%3%^(B
;;;     $B%s%I$r;H$&$3$H$,$G$-$^$;$s!#8e<T$O(B Emacs ver.18 $B$K(B minibuffer- 
;;;     setup-hook $B$KAjEv$9$k$b$N$,L5$$$?$a$J$N$G$9$,!"2r7h:v$r$4B8CN(B
;;;     $B$NJ}$,$$$i$C$7$c$$$^$7$?$i65$($F2<$5$$!#(B

(defvar super-smart-find-switch-strings (list "=")
  "* smart-find-file $B$N5!G=$K@Z$j49$($k$?$a$NJ8;z!"$^$?$OJ8;z$N%j%9%H!#(B")

(defvar super-smart-find-self-insert-command-list nil
  "* $B4{CN$N(B self-insert-command $B$N%j%9%H!#(Bnil $B$G$O(B apropos $B$G8!:w$9$k(B")

;(autoload 'smart-find-file-match "smart-find" nil t)
;(autoload 'smart-find-file-internal "smart-find" nil t)
(let ((dont-bind-my-keys t))
  (load-library "smart-find")
  )

(if (not (fboundp 'member))
    (defun member (elt list)
  "Return non-nil if ELT is an element of LIST.  Comparison done with EQUAL.
The value is actually the tail of LIST whose car is ELT."
      (while (and list (not (equal elt (car list))))
	(setq list (cdr list)))
      list)
  )

(if (not (fboundp 'add-hook))
    (defun add-hook (hook function &optional append)
      "Add to the value of HOOK the function FUNCTION.
FUNCTION is not added if already present.
FUNCTION is added (if necessary) at the beginning of the hook list
unless the optional argument APPEND is non-nil, in which case
FUNCTION is added at the end.
HOOK should be a symbol, and FUNCTION may be any valid function.  If
HOOK is void, it is first set to nil.  If HOOK's value is a single
function, it is changed to a list of functions."
      (or (boundp hook) (set hook nil))
      ;; If the hook value is a single function, turn it into a list.
      (let ((old (symbol-value hook)))
	(if (or (not (listp old)) (eq (car old) 'lambda))
	    (set hook (list old))))
      (or (if (consp function)
	      ;; Clever way to tell whether a given lambda-expression
	      ;; is equal to anything in the hook.
	      (let ((tail (assoc (cdr function) (symbol-value hook))))
		(equal function tail))
	    (memq function (symbol-value hook)))
	  (set hook
	       (if append
		   (nconc (symbol-value hook) (list function))
		 (cons function (symbol-value hook)))))))

(if (not (fboundp 'remove-hook))
    (defun remove-hook (hook-var function)
      "Remove a function from a hook, if it is present.
First argument HOOK-VAR (a symbol) is the name of a hook, second
 argument FUNCTION is the function to remove (compared with `eq')."
      (let (val)
	(cond ((not (boundp hook-var))
	       nil)
	      ((eq function (setq val (symbol-value hook-var)))
	       (setq hook-var nil))
	      ((consp val)
	       ;; don't side-effect the list
	       (set hook-var (delq function (copy-sequence val))))))))

;(require 'cl)
(if (not (fboundp 'ignore-errors))
    (progn
      (defvar *gensym-counter* 0)
      (defun gensym (&optional arg)
	"Generate a new uninterned symbol.
The name is made by appending a number to PREFIX, default \"G\"."
	(let ((prefix (if (stringp arg) arg "G"))
	      (num (if (integerp arg) arg
		     (prog1 *gensym-counter*
		       (setq *gensym-counter* (1+ *gensym-counter*))))))
	  (make-symbol (format "%s%d" prefix num))))

      (defmacro ignore-errors (&rest body)
	"Execute FORMS; if an error occurs, return nil.
Otherwise, return result of last FORM."
	(let ((err (gensym)))
	  (list 'condition-case err (cons 'progn body) '(error nil))))
      ))

(defun super-smart-find-file-internal (prompt cmd &optional dired-cmd)
  (let ((ddir (if (string-match (concat "^" (expand-file-name "~"))
				default-directory)
		  (concat "~" (substring default-directory (match-end 0)))
		default-directory))
	(owindow (get-buffer-window (current-buffer)))
	char-1 char-2 char-3 str smart func func-x fname empty)
    (message (concat prompt ddir))
    (let ((cursor-in-echo-area t))
      (setq char-1 (ignore-errors (read-char))))
    (setq str (and char-1 (char-to-string char-1)))
    (if (member str super-smart-find-switch-strings)
	(progn
	  (completing-read (concat "Smart " prompt)
			   'smart-find-file-internal nil t nil)
	  (setq fname smart-find-file-match)
	  (setq smart t))
      (and char-1
	   (progn
	     (select-window (minibuffer-window))
	     (setq func
		   (or
		    (or
		     (cdr (assoc char-1 (cdr minibuffer-local-completion-map)))
		     (cdr (assoc char-1 (cdr minibuffer-local-map))))
		    (key-binding str)))
	     (select-window owindow)))
      (cond ((memq func
		   (or super-smart-find-self-insert-command-list
		       (if (>= (string-to-int emacs-version) 19)
			   (apropos-internal "self-insert-command" 'commandp)
			 (let ((conf (current-window-configuration)))
			   (prog1
			       (apropos "self-insert-command" 'commandp)
			     (kill-buffer (get-buffer "*Help*"))
			     (set-window-configuration conf)
			     )))))
	     (if (>= (string-to-int emacs-version) 19)
		 (progn
		   (fset 'super-smart-find-minibuffer-setup-hook
			 (function (lambda ()
				     (remove-hook
				      'minibuffer-setup-hook
				      'super-smart-find-minibuffer-setup-hook)
				     (insert str))))
		   (add-hook 'minibuffer-setup-hook
			     'super-smart-find-minibuffer-setup-hook t)
		   (setq fname (read-file-name prompt))
		   )
	       (setq fname (read-file-name prompt (concat ddir str)))
	       ))
	    ((commandp func)
	     (if (eq func 'exit-minibuffer)
		 (setq empty t)
	       (fset 'super-smart-find-minibuffer-setup-hook
		     (function (lambda ()
				 (remove-hook
				  'minibuffer-setup-hook
				  'super-smart-find-minibuffer-setup-hook)
				 (ignore-errors (call-interactively func))
				 )))
	       (add-hook 'minibuffer-setup-hook
			 'super-smart-find-minibuffer-setup-hook t)
	       (setq fname (read-file-name prompt))
	       ))
	    ((keymapp func)
	     (setq func-x func)
	     (message (concat prompt ddir))
	     (let ((cursor-in-echo-area t))
	       (setq char-2 (ignore-errors (read-char))))
	     (cond ((listp func)
		    (setq func (and char-2 (cdr (assoc char-2 (cdr func)))))
		    ; (if (commandp func)
		    (if (or (memq func '(previous-history-element
					 next-history-element))
			    (eq func-x 'help-command))
			(progn
			  (fset 'super-smart-find-minibuffer-setup-hook
				(function
				 (lambda ()
				   (remove-hook
				    'minibuffer-setup-hook
				    'super-smart-find-minibuffer-setup-hook)
				   (let ((cursor-in-echo-area t))
				     (ignore-errors (call-interactively func))
				     ))))
			  (add-hook 'minibuffer-setup-hook
				    'super-smart-find-minibuffer-setup-hook t)
			  (setq fname (read-file-name prompt))
			  )
		      (setq fname (read-file-name prompt))
		      ))
		   (t
		    (select-window (minibuffer-window))
		    (setq func (key-binding
				(concat str (char-to-string char-2))))
		    (select-window owindow)
		    (if (or (memq func '(previous-history-element
					 next-history-element))
			    (eq func-x 'help-command))
			(progn
			  (fset 'super-smart-find-minibuffer-setup-hook
				(function
				 (lambda ()
				   (remove-hook
				    'minibuffer-setup-hook
				    'super-smart-find-minibuffer-setup-hook)
				   (let ((cursor-in-echo-area t))
				     (ignore-errors (call-interactively func))
				     ))))
			  (add-hook 'minibuffer-setup-hook
				    'super-smart-find-minibuffer-setup-hook t)
			  (setq fname (read-file-name prompt))
			  )
		      (setq func-x func)
		      (message (concat prompt ddir))
		      (let ((cursor-in-echo-area t))
			(setq char-3 (ignore-errors (read-char))))
		      (and char-3
			   (progn
			     (select-window (minibuffer-window))
			     (setq func (key-binding
					 (concat str
						 (char-to-string char-2)
						 (char-to-string char-3)
						 )))
			     (select-window owindow)
			     ))
		      ; (if (commandp func)
		      (if (or (memq func '(previous-history-element
					   next-history-element))
			      (eq func-x 'help-command))
			  (progn
			    (fset 'super-smart-find-minibuffer-setup-hook
				  (function
				   (lambda ()
				     (remove-hook
				      'minibuffer-setup-hook
				      'super-smart-find-minibuffer-setup-hook)
				     (let ((cursor-in-echo-area t))
				       (ignore-errors
					 (call-interactively func))
				       ))))
			    (add-hook 'minibuffer-setup-hook
				      'super-smart-find-minibuffer-setup-hook
				      t)
			    (setq fname (read-file-name prompt))
			    )
			(setq fname (read-file-name prompt))
			)))))
	    (t
	     (setq fname (read-file-name prompt))
	     ))
      )
    (if empty
	(cond ((memq cmd '(insert-file write-file load-file))
	       (if (buffer-file-name)
		   (funcall
		    cmd (concat default-directory
				(file-name-nondirectory (buffer-file-name))))
		 (funcall cmd ddir)
		 ))
	      ((eq cmd 'mime-insert-file)
	       (error
		(concat "Opening input file: file is a directory, " ddir)))
	      (t
	       (funcall dired-cmd ddir)
	       ))
      (cond ((eq cmd 'write-file)
	     (if smart
		 (if (y-or-n-p (concat prompt fname " "))
		     (write-file fname)
		   (error "")
		   ))
	     (funcall cmd fname)
	     )
	    ((eq cmd 'load-file)
	     (if smart
		 (message (concat "Loading file " fname "...")))
	     (funcall cmd fname)
	     (if smart
		 (message (concat "Loading file " fname "...done")))
	     )
	    (t
	     (if smart
		 (message (concat "Reading file " fname "...")))
	     (funcall cmd fname)
	     (if smart
		 (message (concat "Reading file " fname "...done")))
	     ))
      )
    ))

(defun super-smart-find-file ()
  (interactive)
  (super-smart-find-file-internal "Find file: " 'find-file 'dired)
  )

(defun super-smart-find-file-other-window ()
  (interactive)
  (super-smart-find-file-internal "Find file in other window: "
				  'find-file-other-window 'dired-other-window)
  )

(defun super-smart-find-insert-file ()
  (interactive)
  (super-smart-find-file-internal "Insert file: " 'insert-file)
  )

(defun super-smart-find-write-file ()
  (interactive)
  (super-smart-find-file-internal "Write file: " 'write-file)
  )

(defun super-smart-find-file-other-frame ()
  (interactive)
  (super-smart-find-file-internal "Find file in other frame: "
				  'find-file-other-frame 'dired-other-frame)
  )

(defun super-smart-find-load-file ()
  (interactive)
  (super-smart-find-file-internal "Load file: " 'load-file)
  )

(defun super-smart-find-mime-insert-file-internal (file)
; Insert a message from a file.
  (let*  ((guess (mime-find-file-type file))
	  (pritype (nth 0 guess))
	  (subtype (nth 1 guess))
	  (parameters (nth 2 guess))
	  (default (nth 3 guess))	;Guess encoding from its file name.
	  (encoding
	   (completing-read
	    (concat "What transfer encoding"
		    (if default
			(concat " (default "
				(if (string-equal default "") "\"\"" default)
				")"
				))
		    ": ")
	    mime-transfer-encoders nil t nil)))
    (if (string-equal encoding "")
	(setq encoding default))
    (mime-insert-tag pritype subtype parameters)
    (mime-insert-binary-file file encoding)))

(defun super-smart-find-mime-insert-file ()
  (interactive)
  (super-smart-find-file-internal "Insert file as MIME message: "
				  'super-smart-find-mime-insert-file-internal)
  )

; super-smart-find.el ends here
